DECLARE FUNCTION filelength# (FileName$)
DECLARE SUB absolute (FileName AS STRING, Address AS INTEGER)

'from "Microsoft QuickBasic Bible" by the Waite Group of Microsoft Press
'filelength# returns the size of a file in bytes. It doesn't require a
'free file handle. If the size returned is 0, the file does not exist.


'load machine-language code
  DIM mCode(1 TO 70) AS LONG
  DIM Byte AS STRING * 2
  DEF SEG = VARSEG(mCode(1))
  offSet% = VARPTR(mCode(30))
  RESTORE
  FOR i% = 0 TO 161
    READ Byte
    POKE offSet% + i%, VAL("&H" + Byte)
  NEXT i%

'example
PRINT filelength#("qb.exe")

DATA 55,8B,EC,06,1E,57,56,2E,C7,06,00,00,00,00,2E
DATA C7,06,02,00,00,00,0E,07,8B,5E,06,8B,0F,83,F9
DATA 01,72,6F,83,F9,40,77,6A,8B,77,02,BF,33,00,FC
DATA F3,A4,B0,00,AA,0E,1F,B4,2F,CD,21,2E,89,1E,2F
DATA 00,2E,8C,06,31,00,BA,04,00,B4,1A,CD,21,BA,33
DATA 00,33,C9,B4,4E,CD,21,72,2D,2E,A1,1E,00,2E,8B
DATA 16,20,00,2E,A3,00,00,2E,89,16,02,00,B4,4F,CD
DATA 21,72,15,2E,A1,1E,00,2E,8B,16,20,00,2E,01,06
DATA 00,00,2E,11,16,02,00,EB,E5,2E,A1,31,00,2E,8B
DATA 16,2F,00,8E,D8,B4,1A,CD,21,2E,8B,16,02,00,2E
DATA A1,00,00,5E,5F,1F,07,5D,CA,02,00,00

FUNCTION filelength# (FileName$)
  SHARED mCode() AS LONG
  IF LEN(FileName$) > 0 AND LEN(FileName$) < 65 THEN
    absolute FileName$, VARPTR(mCode(30))
    filelength# = mCode(1)
  END IF
END FUNCTION

